Index: LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_transfert_para.F90	(revision 987)
@@ -1614,19 +1246,10 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3)
-      REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3
-      REAL,DIMENSION(s1,s2,s3) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))  :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
   
   END SUBROUTINE reduce_sum_r3  
@@ -1639,20 +1262,11 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    CALL body(VarIn,VarOut,SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))
-    
-  CONTAINS
-    SUBROUTINE body(VarIn,VarOut,s1,s2,s3,s4)
-      REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
-      REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
-      INTEGER,INTENT(IN) :: s1,s2,s3,s4
-      REAL,DIMENSION(s1,s2,s3,s4) :: Var_tmp
-      
-      CALL reduce_sum_omp(VarIn,Var_tmp)
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))  :: Var_tmp
+           
+    CALL reduce_sum_omp(VarIn,Var_tmp)
 !$OMP MASTER      
-      CALL reduce_sum_mpi(Var_tmp,VarOut)
-!$OMP END MASTER
-
-    END SUBROUTINE body
-   
+    CALL reduce_sum_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
   END SUBROUTINE reduce_sum_r4  
 
Index: LMDZ4/trunk/libf/phylmd/mod_surf_para.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/mod_surf_para.F90	(revision 987)
+++ LMDZ4/trunk/libf/phylmd/mod_surf_para.F90	(revision 987)
@@ -0,0 +1,350 @@
+MODULE mod_surf_para
+  IMPLICIT NONE
+  
+  INTERFACE gather_surf
+    MODULE PROCEDURE gather_surf_i,gather_surf_r
+  END INTERFACE gather_surf
+  
+  INTERFACE gather_surf_omp
+    MODULE PROCEDURE gather_surf_omp_i,gather_surf_omp_r
+  END INTERFACE gather_surf_omp
+
+  INTERFACE gather_surf_mpi
+    MODULE PROCEDURE gather_surf_mpi_i,gather_surf_mpi_r
+  END INTERFACE gather_surf_mpi
+
+  INTERFACE scatter_surf
+    MODULE PROCEDURE scatter_surf_i,scatter_surf_r
+  END INTERFACE scatter_surf
+  
+  INTERFACE scatter_surf_omp
+    MODULE PROCEDURE scatter_surf_omp_i,scatter_surf_omp_r
+  END INTERFACE scatter_surf_omp
+
+  INTERFACE scatter_surf_mpi
+    MODULE PROCEDURE scatter_surf_mpi_i,scatter_surf_mpi_r
+  END INTERFACE scatter_surf_mpi
+  
+  
+  INTEGER,SAVE             :: knon_omp
+  INTEGER,SAVE             :: knon_omp_begin
+  INTEGER,SAVE             :: knon_omp_end
+!$OMP THREADPRIVATE(knon_omp,knon_omp_begin,knon_omp_end)
+  INTEGER,ALLOCATABLE,SAVE :: knon_omp_para(:)
+  INTEGER,ALLOCATABLE,SAVE :: knon_omp_begin_para(:)
+  INTEGER,ALLOCATABLE,SAVE :: knon_omp_end_para(:)
+  
+  INTEGER,SAVE             :: knon_mpi
+  INTEGER,ALLOCATABLE,SAVE :: knon_mpi_para(:)
+  INTEGER,ALLOCATABLE,SAVE :: knon_mpi_begin_para(:)
+  INTEGER,ALLOCATABLE,SAVE :: knon_mpi_end_para(:)
+  
+  INTEGER,SAVE             :: knon_glo
+  INTEGER,SAVE,ALLOCATABLE :: knon_glo_para(:)  
+  INTEGER,ALLOCATABLE,SAVE :: knon_glo_begin_para(:)
+  INTEGER,ALLOCATABLE,SAVE :: knon_glo_end_para(:)
+  
+  
+CONTAINS
+
+  SUBROUTINE Init_surf_para(knon)
+  USE mod_phys_lmdz_para, mpi_rank_root=>mpi_root
+#ifdef CPP_PARA
+  INCLUDE 'mpif.h'
+#endif
+    INTEGER :: knon
+    INTEGER :: i,ierr
+    
+    knon_omp=knon
+    IF (is_omp_root) THEN
+      ALLOCATE(knon_omp_para(0:omp_size-1))
+      ALLOCATE(knon_omp_begin_para(0:omp_size-1))
+      ALLOCATE(knon_omp_end_para(0:omp_size-1))
+    ENDIF
+!$OMP BARRIER
+    knon_omp_para(omp_rank)=knon
+!$OMP BARRIER
+    IF (is_omp_root) THEN 
+      knon_omp_begin_para(0)=1
+      knon_omp_end_para(0)=knon_omp_para(0)
+      DO i=1,omp_size-1
+        knon_omp_begin_para(i)=knon_omp_end_para(i-1)+1
+        knon_omp_end_para(i)=knon_omp_begin_para(i)+knon_omp_para(i)-1
+      ENDDO
+    ENDIF 
+!$OMP BARRIER
+    knon_omp_begin=knon_omp_begin_para(omp_rank)
+    knon_omp_end=knon_omp_end_para(omp_rank)
+!$OMP BARRIER    
+    IF (is_omp_root) THEN
+      knon_mpi=sum(knon_omp_para)
+      ALLOCATE(knon_mpi_para(0:mpi_size-1))
+      ALLOCATE(knon_mpi_begin_para(0:mpi_size-1))
+      ALLOCATE(knon_mpi_end_para(0:mpi_size-1))
+      
+      ALLOCATE(knon_glo_para(0:mpi_size*omp_size-1))
+      ALLOCATE(knon_glo_begin_para(0:mpi_size*omp_size-1))
+      ALLOCATE(knon_glo_end_para(0:mpi_size*omp_size-1))
+      
+      IF (is_ok_mpi) THEN
+#ifdef CPP_PARA
+        CALL MPI_ALLGather(knon_mpi,1,MPI_INTEGER,knon_mpi_para,1,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
+        CALL MPI_ALLGather(knon_omp_para,omp_size,MPI_INTEGER,knon_glo_para,omp_size,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
+#endif
+      ELSE
+        knon_mpi_para(:)=knon_mpi
+        knon_glo_para(:)=knon_omp_para(:)
+      ENDIF     
+      
+      knon_glo=sum(knon_mpi_para(:))
+      
+      knon_mpi_begin_para(0)=1
+      knon_mpi_end_para(0)=knon_mpi_para(0)
+      DO i=1,mpi_size-1
+        knon_mpi_begin_para(i)=knon_mpi_end_para(i-1)+1
+        knon_mpi_end_para(i)=knon_mpi_begin_para(i)+knon_mpi_para(i)-1
+      ENDDO
+      
+      knon_glo_begin_para(0)=1
+      knon_glo_end_para(0)=knon_glo_para(0)
+      DO i=1,mpi_size*omp_size-1
+        knon_glo_begin_para(i)=knon_glo_end_para(i-1)
+        knon_glo_end_para(i)= knon_glo_begin_para(i)+knon_glo_para(i)-1
+      ENDDO
+   ENDIF
+!$OMP BARRIER
+
+  END SUBROUTINE Init_surf_para
+
+ 
+  SUBROUTINE Finalize_surf_para
+  USE mod_phys_lmdz_para
+
+!$OMP BARRIER   
+   IF (is_omp_root) THEN
+      DEALLOCATE(knon_omp_para)
+      DEALLOCATE(knon_omp_begin_para)
+      DEALLOCATE(knon_omp_end_para)
+      DEALLOCATE(knon_mpi_para)
+      DEALLOCATE(knon_mpi_begin_para)
+      DEALLOCATE(knon_mpi_end_para)
+      DEALLOCATE(knon_glo_para)  
+      DEALLOCATE(knon_glo_begin_para)
+      DEALLOCATE(knon_glo_end_para)
+    ENDIF
+    
+  END SUBROUTINE Finalize_surf_para
+  
+  
+  SUBROUTINE gather_surf_i(FieldIn, FieldOut)
+  USE mod_phys_lmdz_para
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+    INTEGER :: FieldTmp(knon_mpi)
+    
+    CALL gather_surf_omp_i(FieldIn,FieldTmp)
+    IF (is_omp_root) CALL gather_surf_mpi_i(FieldTmp,FieldOut)
+    
+  END SUBROUTINE gather_surf_i
+
+
+  SUBROUTINE gather_surf_omp_i(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+  
+    INTEGER,SAVE,ALLOCATABLE :: Field_tmp(:)
+    
+    IF (is_omp_root) ALLOCATE(Field_tmp(knon_mpi))
+!$OMP BARRIER
+    Field_tmp(knon_omp_begin:knon_omp_end)=FieldIn(:)
+!$OMP BARRIER        
+    IF (is_omp_root) FieldOut(:)=Field_tmp(:)
+!$OMP BARRIER
+    IF (is_omp_root) DEALLOCATE(Field_tmp)
+    
+  END SUBROUTINE  gather_surf_omp_i
+  
+     
+  SUBROUTINE gather_surf_mpi_i(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para, mpi_rank_root => mpi_root
+#ifdef CPP_PARA
+  INCLUDE 'mpif.h'
+#endif
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+    INTEGER :: ierr
+    
+    IF (is_ok_mpi) THEN
+#ifdef CPP_PARA
+      CALL MPI_Gatherv(FieldIn,knon_mpi,MPI_INTEGER,                                &
+                       FieldOut,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER, &
+                       mpi_rank_root,COMM_LMDZ_PHY,ierr)
+#endif
+    ELSE
+      FieldOut(:)=FieldIn(:)
+    ENDIF
+  
+  END SUBROUTINE gather_surf_mpi_i
+  
+
+
+
+
+  SUBROUTINE gather_surf_r(FieldIn, FieldOut)
+  USE mod_phys_lmdz_para
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+    REAL :: FieldTmp(knon_mpi)
+    
+    CALL gather_surf_omp_r(FieldIn,FieldTmp)
+    IF (is_omp_root) CALL gather_surf_mpi_r(FieldTmp,FieldOut)
+    
+  END SUBROUTINE gather_surf_r
+
+
+  SUBROUTINE gather_surf_omp_r(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+  
+    REAL,SAVE,ALLOCATABLE :: Field_tmp(:)
+    
+    IF (is_omp_root) ALLOCATE(Field_tmp(knon_mpi))
+!$OMP BARRIER
+    Field_tmp(knon_omp_begin:knon_omp_end)=FieldIn(:)
+!$OMP BARRIER        
+    IF (is_omp_root) FieldOut(:)=Field_tmp(:)
+!$OMP BARRIER
+    IF (is_omp_root) DEALLOCATE(Field_tmp)
+    
+  END SUBROUTINE  gather_surf_omp_r
+  
+     
+  SUBROUTINE gather_surf_mpi_r(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para, mpi_rank_root => mpi_root
+#ifdef CPP_PARA
+  INCLUDE 'mpif.h'
+#endif
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+    REAL :: ierr
+    
+    IF (is_ok_mpi) THEN
+#ifdef CPP_PARA
+      CALL MPI_Gatherv(FieldIn,knon_mpi,MPI_REAL_LMDZ,                                 &
+                       FieldOut,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_REAL_LMDZ,  &
+                       mpi_rank_root,COMM_LMDZ_PHY,ierr)            
+#endif
+    ELSE
+      FieldOut(:)=FieldIn(:)
+    ENDIF
+  
+  END SUBROUTINE gather_surf_mpi_r
+
+
+
+
+  SUBROUTINE scatter_surf_i(FieldIn, FieldOut)
+  USE mod_phys_lmdz_para
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+    INTEGER :: FieldTmp(knon_mpi)
+    
+    IF (is_omp_root) CALL scatter_surf_mpi_i(FieldIn,FieldTmp)
+    CALL scatter_surf_omp_i(FieldTmp,FieldOut)
+    
+  END SUBROUTINE scatter_surf_i
+
+
+  SUBROUTINE scatter_surf_omp_i(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+  
+    INTEGER,SAVE,ALLOCATABLE :: Field_tmp(:)
+    
+    IF (is_omp_root) ALLOCATE(Field_tmp(knon_mpi))
+    IF (is_omp_root) Field_tmp(:)=FieldIn(:)
+!$OMP BARRIER        
+    FieldOut(:)=Field_tmp(knon_omp_begin:knon_omp_end)
+!$OMP BARRIER
+    IF (is_omp_root) DEALLOCATE(Field_tmp)
+    
+  END SUBROUTINE  scatter_surf_omp_i
+  
+     
+  SUBROUTINE scatter_surf_mpi_i(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para, mpi_rank_root => mpi_root
+#ifdef CPP_PARA
+  INCLUDE 'mpif.h'
+#endif
+    INTEGER :: FieldIn(:)
+    INTEGER :: FieldOut(:)
+    INTEGER :: ierr
+    
+    IF (is_ok_mpi) THEN
+#ifdef CPP_PARA
+      CALL MPI_Scatterv(FieldIn,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER,   &
+                        FieldOut,knon_mpi,MPI_INTEGER,                                &
+                        mpi_rank_root,COMM_LMDZ_PHY,ierr)
+#endif
+    ELSE
+      FieldOut(:)=FieldIn(:)
+    ENDIF
+  
+  END SUBROUTINE scatter_surf_mpi_i
+
+
+
+  SUBROUTINE scatter_surf_r(FieldIn, FieldOut)
+  USE mod_phys_lmdz_para
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+    REAL :: FieldTmp(knon_mpi)
+    
+    IF (is_omp_root) CALL scatter_surf_mpi_r(FieldIn,FieldTmp)
+    CALL scatter_surf_omp_r(FieldTmp,FieldOut)
+    
+  END SUBROUTINE scatter_surf_r
+
+
+  SUBROUTINE scatter_surf_omp_r(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+  
+    INTEGER,SAVE,ALLOCATABLE :: Field_tmp(:)
+    
+    IF (is_omp_root) ALLOCATE(Field_tmp(knon_mpi))
+    IF (is_omp_root) Field_tmp(:)=FieldIn(:)
+!$OMP BARRIER        
+    FieldOut(:)=Field_tmp(knon_omp_begin:knon_omp_end)
+!$OMP BARRIER
+    IF (is_omp_root) DEALLOCATE(Field_tmp)
+    
+  END SUBROUTINE  scatter_surf_omp_r
+  
+     
+  SUBROUTINE scatter_surf_mpi_r(FieldIn,FieldOut)
+  USE mod_phys_lmdz_para, mpi_rank_root => mpi_root
+#ifdef CPP_PARA
+  INCLUDE 'mpif.h'
+#endif
+    REAL :: FieldIn(:)
+    REAL :: FieldOut(:)
+    INTEGER :: ierr
+    
+    IF (is_ok_mpi) THEN
+#ifdef CPP_PARA
+      CALL MPI_Scatterv(FieldIn,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER,   &
+                        FieldOut,knon_mpi,MPI_INTEGER,                                &
+                        mpi_rank_root,COMM_LMDZ_PHY,ierr)
+#endif
+    ELSE
+      FieldOut(:)=FieldIn(:)
+    ENDIF
+  
+  END SUBROUTINE scatter_surf_mpi_r
+
+END MODULE mod_surf_para
Index: LMDZ4/trunk/libf/phylmd/mod_synchro_omp.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/mod_synchro_omp.F90	(revision 987)
+++ LMDZ4/trunk/libf/phylmd/mod_synchro_omp.F90	(revision 987)
@@ -0,0 +1,34 @@
+MODULE mod_synchro_omp
+
+  LOGICAL,SAVE,ALLOCATABLE :: flag_omp(:)
+  
+CONTAINS
+
+  SUBROUTINE Init_synchro_omp
+  USE mod_phys_lmdz_para 
+  IMPLICIT NONE
+    
+    IF (is_omp_root) THEN
+      ALLOCATE(flag_omp(0:omp_size-1))
+      flag_omp(:)=.FALSE.
+    ENDIF
+!$OMP BARRIER
+
+  END SUBROUTINE Init_Synchro_omp
+  
+  SUBROUTINE Synchro_omp
+  USE mod_phys_lmdz_para
+  IMPLICIT NONE
+  
+    flag_omp(omp_rank)=.TRUE.
+!$OMP BARRIER
+    DO WHILE (.NOT. ALL(flag_omp))
+!$OMP BARRIER
+    ENDDO
+!$OMP BARRIER        
+    flag_omp(omp_rank)=.FALSE.
+!$OMP BARRIER
+
+   END SUBROUTINE Synchro_omp
+
+END MODULE mod_synchro_omp
Index: LMDZ4/trunk/libf/phylmd/oasis.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/oasis.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/oasis.F90	(revision 987)
@@ -44,4 +44,5 @@
   !$OMP THREADPRIVATE(out_var_id)
 
+  CHARACTER(LEN=*),PARAMETER :: OPA_version='OPA9'
 
 #ifdef CPP_COUPLE
@@ -129,31 +130,65 @@
 !     Define symbolic name for fields exchanged from atmos to coupler,
 !         must be the same as (1) of the field  definition in namcouple:
-    cl_writ(1)='COTAUXXU'
-    cl_writ(2)='COTAUYYU'
-    cl_writ(3)='COTAUZZU'
-    cl_writ(4)='COTAUXXV'
-    cl_writ(5)='COTAUYYV'
-    cl_writ(6)='COTAUZZV'
-    cl_writ(7)='COWINDSP'
-    cl_writ(8)='COSHFICE'
-    cl_writ(9)='COSHFOCE'
-    cl_writ(10)='CONSFICE'
-    cl_writ(11)='CONSFOCE'
-    cl_writ(12)='CODFLXDT'
-    cl_writ(13)='COTFSICE'
-    cl_writ(14)='COTFSOCE'
-    cl_writ(15)='COTOLPSU'
-    cl_writ(16)='COTOSPSU'
-    cl_writ(17)='CORUNCOA'
-    cl_writ(18)='CORIVFLU'
-    cl_writ(19)='COCALVIN'
+    IF (OPA_version=='OPA9') THEN
+      cl_writ(1)='COTAUXXU'
+      cl_writ(2)='COTAUYYU'
+      cl_writ(3)='COTAUZZU'
+      cl_writ(4)='COTAUXXV'
+      cl_writ(5)='COTAUYYV'
+      cl_writ(6)='COTAUZZV'
+      cl_writ(7)='COWINDSP'
+      cl_writ(8)='COPEFWAT'
+      cl_writ(9)='COPEFICE'
+      cl_writ(10)='COTOSPSU'
+      cl_writ(11)='COICEVAP'
+      cl_writ(12)='COSWFLDO'
+      cl_writ(13)='CONSFLDO'
+      cl_writ(14)='COSHFLIC'
+      cl_writ(15)='CONSFLIC'
+      cl_writ(16)='CODFLXDT'
+      cl_writ(17)='CRWOCEIS'
+      cl_writ(18)='CRWOCERD'
+      cl_writ(19)='CRWOCECD'
+    ELSE IF (OPA_version=='OPA8') THEN
+      cl_writ(1)='COTAUXXU'
+      cl_writ(2)='COTAUYYU'
+      cl_writ(3)='COTAUZZU'
+      cl_writ(4)='COTAUXXV'
+      cl_writ(5)='COTAUYYV'
+      cl_writ(6)='COTAUZZV'
+      cl_writ(7)='COWINDSP'
+      cl_writ(8)='COSHFICE'
+      cl_writ(9)='COSHFOCE'
+      cl_writ(10)='CONSFICE'
+      cl_writ(11)='CONSFOCE'
+      cl_writ(12)='CODFLXDT'
+      cl_writ(13)='COTFSICE'
+      cl_writ(14)='COTFSOCE'
+      cl_writ(15)='COTOLPSU'
+      cl_writ(16)='COTOSPSU'
+      cl_writ(17)='CORUNCOA'
+      cl_writ(18)='CORIVFLU'
+      cl_writ(19)='COCALVIN'
+    ELSE
+      STOP 'Bad OPA version for coupled model'
+    ENDIF
+
 !
 !     Define symbolic name for fields exchanged from coupler to atmosphere,
 !         must be the same as (2) of the field  definition in namcouple:
 !
-    cl_read(1)='SISUTESW'
-    cl_read(2)='SIICECOV'
-    cl_read(3)='SIICEALW'
-    cl_read(4)='SIICTEMW'
+    IF (OPA_version=='OPA9') THEN
+      cl_read(1)='SISUTESW'
+      cl_read(2)='SIICECOV'
+      cl_read(4)='SIICEALW'
+      cl_read(3)='SIICTEMW'
+    ELSE IF (OPA_version=='OPA8') THEN
+      cl_read(1)='SISUTESW'
+      cl_read(2)='SIICECOV'
+      cl_read(3)='SIICEALW'
+      cl_read(4)='SIICTEMW'
+    ELSE
+      STOP 'Bad OPA version for coupled model'
+    ENDIF
     
     il_var_nodims(1) = 2
@@ -286,14 +321,15 @@
 ! Local variables
 !************************************************************************************
-    LOGICAL                     :: checkout=.FALSE.
-    INTEGER                     :: istart,iend
-    INTEGER                     :: wstart,wend
-    INTEGER, PARAMETER          :: nuout = 6 
-    INTEGER                     :: ierror, i
-    REAL, DIMENSION(iim*jj_nb)  :: field
-    CHARACTER (len = 20),SAVE   :: modname = 'intocpl'
-    CHARACTER (len = 80)        :: abort_message 
-
-!************************************************************************************
+    LOGICAL                          :: checkout
+    INTEGER                          :: istart,iend
+    INTEGER                          :: wstart,wend
+    INTEGER, PARAMETER               :: nuout = 6 
+    INTEGER                          :: ierror, i
+    REAL, DIMENSION(iim*jj_nb)       :: field
+    CHARACTER (len = 20),PARAMETER   :: modname = 'intocpl'
+    CHARACTER (len = 80)             :: abort_message 
+
+!************************************************************************************
+    checkout=.FALSE.
 
     WRITE(nuout,*) ' '
Index: LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 987)
@@ -487,5 +487,7 @@
   LOGICAL ok_flux_surf
   data ok_flux_surf/.false./
+!ym pas glop !!
     common /flux_arp/fsens,flat,ok_flux_surf
+!$OMP THREADPRIVATE(/flux_arp/)
 
 !****************************************************************************************
Index: LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 987)
@@ -109,5 +109,4 @@
       PARAMETER (length=100)
       REAL tab_cntrl(length), tabcntr0(length)
-      REAL,SAVE :: tab_cntrl_omp(length)
       CHARACTER*7 str7
       CHARACTER*2 str2
@@ -232,6 +231,5 @@
 c Lecture des latitudes (coordonnees):
 c
-c$OMP MASTER
-      IF (is_mpi_root) THEN
+      IF (is_mpi_root .AND. is_omp_root) THEN
       
       ierr = NF_INQ_VARID (nid, "latitude", nvarid)
@@ -957,10 +955,4 @@
       PRINT*,'Rayonnement IF au sol sollw:', xmin, xmax
       
-      ENDIF  ! is_mpi_root
-c$OMP END MASTER
-
-
-c$OMP MASTER
-      IF (is_mpi_root) THEN
 c
 c Lecture derive des flux:
@@ -1729,7 +1721,6 @@
 c
       ierr = NF_CLOSE(nid)
-      ENDIF ! is_mpi_root
-c
-c$OMP END MASTER
+      ENDIF ! is_mpi_root .AND. is_omp_root
+c
 
 c$OMP MASTER
Index: LMDZ4/trunk/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 987)
@@ -7,30 +7,53 @@
 ! Declaration des variables
 
-      REAL, ALLOCATABLE :: t_seri(:,:), q_seri(:,:)
-      REAL, ALLOCATABLE :: ql_seri(:,:),qs_seri(:,:)
-      REAL, ALLOCATABLE :: u_seri(:,:), v_seri(:,:)
+      REAL, SAVE, ALLOCATABLE :: t_seri(:,:), q_seri(:,:)
+      !$OMP THREADPRIVATE(t_seri, q_seri)
+      REAL, SAVE, ALLOCATABLE :: ql_seri(:,:),qs_seri(:,:)
+      !$OMP THREADPRIVATE(ql_seri,qs_seri)
+      REAL, SAVE, ALLOCATABLE :: u_seri(:,:), v_seri(:,:)
+      !$OMP THREADPRIVATE(u_seri, v_seri)
 
-      REAL, ALLOCATABLE :: tr_seri(:,:,:)
-      REAL, ALLOCATABLE :: d_t_dyn(:,:), d_q_dyn(:,:)
-      REAL, ALLOCATABLE :: d_t_con(:,:),d_q_con(:,:)
-      REAL, ALLOCATABLE :: d_u_con(:,:),d_v_con(:,:)
-      REAL, ALLOCATABLE :: d_t_wake(:,:),d_q_wake(:,:)
-      REAL, ALLOCATABLE :: d_t_lsc(:,:),d_q_lsc(:,:),d_ql_lsc(:,:)
-      REAL, ALLOCATABLE :: d_t_ajsb(:,:), d_q_ajsb(:,:)
-      REAL, ALLOCATABLE :: d_t_ajs(:,:), d_q_ajs(:,:)
-      REAL, ALLOCATABLE :: d_u_ajs(:,:), d_v_ajs(:,:)
-      REAL, ALLOCATABLE :: d_t_eva(:,:),d_q_eva(:,:)
+      REAL, SAVE, ALLOCATABLE :: tr_seri(:,:,:)
+      !$OMP THREADPRIVATE(tr_seri)
+      REAL, SAVE, ALLOCATABLE :: d_t_dyn(:,:), d_q_dyn(:,:)
+      !$OMP THREADPRIVATE(d_t_dyn, d_q_dyn)
+      REAL, SAVE, ALLOCATABLE :: d_t_con(:,:),d_q_con(:,:)
+      !$OMP THREADPRIVATE(d_t_con,d_q_con)
+      REAL, SAVE, ALLOCATABLE :: d_u_con(:,:),d_v_con(:,:)
+      !$OMP THREADPRIVATE(d_u_con,d_v_con)
+      REAL, SAVE, ALLOCATABLE :: d_t_wake(:,:),d_q_wake(:,:)
+      !$OMP THREADPRIVATE( d_t_wake,d_q_wake)
+      REAL, SAVE, ALLOCATABLE :: d_t_lsc(:,:),d_q_lsc(:,:),d_ql_lsc(:,:)
+      !$OMP THREADPRIVATE(d_t_lsc,d_q_lsc,d_ql_lsc)
+      REAL, SAVE, ALLOCATABLE :: d_t_ajsb(:,:), d_q_ajsb(:,:)
+      !$OMP THREADPRIVATE(d_t_ajsb, d_q_ajsb)
+      REAL, SAVE, ALLOCATABLE :: d_t_ajs(:,:), d_q_ajs(:,:)
+      !$OMP THREADPRIVATE(d_t_ajs, d_q_ajs)
+      REAL, SAVE, ALLOCATABLE :: d_u_ajs(:,:), d_v_ajs(:,:)
+      !$OMP THREADPRIVATE(d_u_ajs, d_v_ajs)
+      REAL, SAVE, ALLOCATABLE :: d_t_eva(:,:),d_q_eva(:,:)
+      !$OMP THREADPRIVATE(d_t_eva,d_q_eva)
 !tendances dues a oro et lif
-      REAL, ALLOCATABLE :: d_t_oli(:,:)
-      REAL, ALLOCATABLE :: d_u_oli(:,:), d_v_oli(:,:)
-      REAL, ALLOCATABLE :: d_t_vdf(:,:), d_q_vdf(:,:)
-      REAL, ALLOCATABLE :: d_u_vdf(:,:), d_v_vdf(:,:)
-      REAL, ALLOCATABLE :: d_t_oro(:,:)
-      REAL, ALLOCATABLE :: d_u_oro(:,:), d_v_oro(:,:)
-      REAL, ALLOCATABLE :: d_t_lif(:,:)
-      REAL, ALLOCATABLE :: d_u_lif(:,:), d_v_lif(:,:)
+      REAL, SAVE, ALLOCATABLE :: d_t_oli(:,:)
+      !$OMP THREADPRIVATE(d_t_oli)
+      REAL, SAVE, ALLOCATABLE :: d_u_oli(:,:), d_v_oli(:,:)
+      !$OMP THREADPRIVATE(d_u_oli, d_v_oli)
+      REAL, SAVE, ALLOCATABLE :: d_t_vdf(:,:), d_q_vdf(:,:)
+      !$OMP THREADPRIVATE( d_t_vdf, d_q_vdf)
+      REAL, SAVE, ALLOCATABLE :: d_u_vdf(:,:), d_v_vdf(:,:)
+      !$OMP THREADPRIVATE(d_u_vdf, d_v_vdf)
+      REAL, SAVE, ALLOCATABLE :: d_t_oro(:,:)
+      !$OMP THREADPRIVATE(d_t_oro)
+      REAL, SAVE, ALLOCATABLE :: d_u_oro(:,:), d_v_oro(:,:)
+      !$OMP THREADPRIVATE(d_u_oro, d_v_oro)
+      REAL, SAVE, ALLOCATABLE :: d_t_lif(:,:)
+      !$OMP THREADPRIVATE(d_t_lif)
+      REAL, SAVE, ALLOCATABLE :: d_u_lif(:,:), d_v_lif(:,:)
+      !$OMP THREADPRIVATE(d_u_lif, d_v_lif)
 ! tendance du a la conersion Ec -> E thermique
-      REAL, ALLOCATABLE :: d_t_ec(:,:)
-      REAL, ALLOCATABLE :: d_ts(:,:), d_tr(:,:,:)
+      REAL, SAVE, ALLOCATABLE :: d_t_ec(:,:)
+      !$OMP THREADPRIVATE(d_t_ec)
+      REAL, SAVE, ALLOCATABLE :: d_ts(:,:), d_tr(:,:,:)
+      !$OMP THREADPRIVATE(d_ts, d_tr)
 CONTAINS
 
Index: LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/physiq.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/physiq.F	(revision 987)
@@ -111,4 +111,5 @@
       integer iflag_radia     ! active ou non le rayonnement (MPL)
       save iflag_radia
+c$OMP THREADPRIVATE(iflag_radia)
 c======================================================================
       LOGICAL check ! Verifier la conservation du modele en eau
@@ -118,4 +119,5 @@
 c======================================================================
       LOGICAL, SAVE :: rnpb=.TRUE.
+c$OMP THREADPRIVATE(rnpb)
 cIM "slab" ocean
       REAL tslab(klon)    !Temperature du slab-ocean
@@ -247,4 +249,5 @@
      .15000., 10000., 7000., 5000., 3000., 2000., 1000./
       SAVE rlevstd
+c$OMP THREADPRIVATE(rlevstd)
       CHARACTER*4 clevSTD(nlevSTD)
       DATA clevSTD/'1000','925 ','850 ','700 ','600 ',
@@ -252,4 +255,5 @@
      .'70  ','50  ','30  ','20  ','10  '/
       SAVE clevSTD
+c$OMP THREADPRIVATE(clevSTD)
 c
       CHARACTER*4 bb2
@@ -353,4 +357,5 @@
 c      INTEGER ncol(napisccp), ncolmx, seed(klon,napisccp)
       INTEGER,SAVE :: ncol(napisccp)
+c$OMP THREADPRIVATE(ncol)
       INTEGER ncolmx, seed(klon,napisccp)
       REAL nbsunlit(nregISCtot,klon,napisccp)  !nbsunlit : moyenne de sunlit
@@ -554,4 +559,6 @@
       REAL qsol(klon)
       REAL,save ::  solarlong0
+c$OMP THREADPRIVATE(solarlong0)
+
 c
 c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
@@ -587,4 +594,5 @@
       INTEGER it_wape_prescr
       SAVE wape_prescr, fip_prescr, it_wape_prescr
+c$OMP THREADPRIVATE(wape_prescr, fip_prescr, it_wape_prescr)
 c
 c variables supplementaires de concvl
@@ -600,4 +608,5 @@
 
 c$OMP THREADPRIVATE(alp_bl_prescr,ale_bl_prescr)
+c$OMP THREADPRIVATE(ale_max,alp_max)
 
       real ale_wake(klon)
@@ -879,4 +888,5 @@
       real ratqsbas,ratqshaut
       save ratqsbas,ratqshaut
+c$OMP THREADPRIVATE(ratqsbas,ratqshaut)
       real zpt_conv(klon,klev)
 
@@ -1505,8 +1515,11 @@
 c#endif
 
+c$OMP MASTER
        call phys_output_open(jjmp1,nqmax,nlevSTD,clevSTD,nbteta, 
      &                        ctetaSTD,dtime,presnivs,ok_veget,
      &                        ocean,iflag_pbl,ok_mensuel,ok_journe,
      &                        ok_hf,ok_instan,nid_files)
+c$OMP END MASTER
+c$OMP BARRIER
 
 #ifdef histISCCP
